namespace Forms.Modules.TEST_MODULE.Antecedents
{
    public abstract class ModelBase_ATCD : global::Forms.Module.Common.Model.ModelEditorBase
    {
        private readonly global::Forms.Module.Common.Model.MultipleInsertModelFieldEditor<global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.Model_incl_antecedents> m_antecedents;

        private readonly global::Forms.Module.Common.Model.StringModelFieldEditor m_erreur_recup_antecedent;

        private readonly global::Forms.Module.Common.Model.StringModelFieldEditor m_uniqueId;

        private readonly global::Forms.Module.Common.Model.StringModelFieldEditor m_folder;

        private readonly global::Forms.Module.Common.Model.StringModelFieldEditor m_actd_import;


        public global::Forms.Module.Common.Model.MultipleInsertModelFieldEditor<global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.Model_incl_antecedents> antecedents
        {
            get
            {
                return m_antecedents;
            }
        }

        public global::Forms.Module.Common.Model.StringModelFieldEditor erreur_recup_antecedent
        {
            get
            {
                return m_erreur_recup_antecedent;
            }
        }

        public global::Forms.Module.Common.Model.StringModelFieldEditor uniqueId
        {
            get
            {
                return m_uniqueId;
            }
        }

        public global::Forms.Module.Common.Model.StringModelFieldEditor folder
        {
            get
            {
                return m_folder;
            }
        }

        public global::Forms.Module.Common.Model.StringModelFieldEditor actd_import
        {
            get
            {
                return m_actd_import;
            }
        }

        public sealed override global::System.Collections.Generic.IEnumerable<global::Forms.Module.Common.Model.ModelFieldEditorBase> Fields
        {
            get
            {
                yield return m_antecedents;
                yield return m_erreur_recup_antecedent;
                yield return m_uniqueId;
                yield return m_folder;
                yield return m_actd_import;
            }
        }


        public ModelBase_ATCD(global::Forms.Module.Common.EditionContext context)
            : base(context, global::Forms.Module.Common.EditionContext.Current.Module.Descriptor.GetEntity<global::Forms.Module.Common.Entities.Model>(new global::System.Guid("3a2f39bfcecb4d8ebbeead45fcc8a932")))
        {
            m_antecedents = new global::Forms.Module.Common.Model.MultipleInsertModelFieldEditor<global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.Model_incl_antecedents>(this, global::Forms.Module.Common.EditionContext.Current.Module.Descriptor.GetEntity<global::Forms.Module.Common.Entities.MultipleInsertModelField>(new global::System.Guid("9de2c361a1e446c7a2fc7bed82bc8823")));
            m_erreur_recup_antecedent = new global::Forms.Module.Common.Model.StringModelFieldEditor(this, global::Forms.Module.Common.EditionContext.Current.Module.Descriptor.GetEntity<global::Forms.Module.Common.Entities.StringModelField>(new global::System.Guid("0ede027f351a4bc59c4d8380789d1764")));
            m_uniqueId = new global::Forms.Module.Common.Model.StringModelFieldEditor(this, global::Forms.Module.Common.EditionContext.Current.Module.Descriptor.GetEntity<global::Forms.Module.Common.Entities.StringModelField>(new global::System.Guid("def84040268e486f9028adc5c1ba47ab")));
            m_folder = new global::Forms.Module.Common.Model.StringModelFieldEditor(this, global::Forms.Module.Common.EditionContext.Current.Module.Descriptor.GetEntity<global::Forms.Module.Common.Entities.StringModelField>(new global::System.Guid("8f8d246c48d845f78b7896dc039ec26c")));
            m_actd_import = new global::Forms.Module.Common.Model.StringModelFieldEditor(this, global::Forms.Module.Common.EditionContext.Current.Module.Descriptor.GetEntity<global::Forms.Module.Common.Entities.StringModelField>(new global::System.Guid("81b2cbaa92e445e08500d8552cb3b327")));
        }

        public void FillModelFromData(ATCD data)
        {
            if(data.antecedents != null) {
                foreach(var item in data.antecedents) {
                    if(item != null) {
                        switch(item.TypeId) {
                            case "7d9babb2120142ed82e366b335c184ec": this.antecedents.Items.Add(global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.ModelBase_incl_antecedents.CreateModelFromData(EditionContext, (global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.incl_antecedents)item)); break;
                        }
                    }
                }
            }
            this.erreur_recup_antecedent.Value = data.erreur_recup_antecedent;
            this.uniqueId.Value = data.uniqueId;
            this.folder.Value = data.folder;
            this.actd_import.Value = data.actd_import;
        }

        public static Model_ATCD CreateModelFromData(global::Forms.Module.Common.EditionContext context, ATCD data)
        {
            var model = new Model_ATCD(context);
            if(data.antecedents != null) {
                foreach(var item in data.antecedents) {
                    if(item != null) {
                        switch(item.TypeId) {
                            case "7d9babb2120142ed82e366b335c184ec": model.antecedents.Items.Add(global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.ModelBase_incl_antecedents.CreateModelFromData(context, (global::Forms.Modules.TEST_MODULE.Antecedents.Inclusions.incl_antecedents)item)); break;
                        }
                    }
                }
            }
            model.erreur_recup_antecedent.Value = data.erreur_recup_antecedent;
            model.uniqueId.Value = data.uniqueId;
            model.folder.Value = data.folder;
            model.actd_import.Value = data.actd_import;
            return model;
        }

        public sealed override global::Forms.Module.Common.Model.ModelFieldEditorBase GetField(global::System.String name)
        {
            switch(name) {
                case "antecedents": return m_antecedents;
                case "erreur_recup_antecedent": return m_erreur_recup_antecedent;
                case "uniqueId": return m_uniqueId;
                case "folder": return m_folder;
                case "actd_import": return m_actd_import;
                default: return null;
            }
        }

        protected abstract void OuvrirATCDDistant(global::Forms.Module.Contracts.IExecutionContext context, global::System.String param_folder, global::System.String param_inclusion_cible);
        protected abstract void ExportATCD(global::Forms.Module.Contracts.IExecutionContext context, global::System.String PARAMETERS);
        public sealed override void CallRemoteFunction(global::Forms.Module.Contracts.IExecutionContext context, string name, global::Forms.Module.Contracts.ObjectNode parameters)
        {
            switch(name) {
                case "OuvrirATCDDistant":
                    OuvrirATCDDistant(context
            , 
                        global::Forms.Module.Contracts.DataNodeExtensions.GetString(parameters, "param_folder")
            , 
                        global::Forms.Module.Contracts.DataNodeExtensions.GetString(parameters, "param_inclusion_cible")
                    );
                    break;
                case "ExportATCD":
                    ExportATCD(context
            , 
                        global::Forms.Module.Contracts.DataNodeExtensions.GetString(parameters, "PARAMETERS")
                    );
                    break;
            }
        }

    }

}

